package concurrentcalc;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Executor;

public class ThreadPoolExecutor implements Executor {

	private final int NTHREADS = 4;
	
	private final BlockingQueue <Runnable> taskQueue = new ArrayBlockingQueue <Runnable> (NTHREADS * 50);
	
	public ThreadPoolExecutor () {
		
		// Erzeuge Threads
		for (int i = 0; i < NTHREADS ; i++) {
			createThread ();
		}
	} 
	
	
	@Override
	public void execute(Runnable task) {

		try {
			taskQueue.put(task);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
	}
	
	private void createThread () {
		Thread t = new Thread (){
			
			public void run () {
				while (true) {
					try {
	
						Runnable task = taskQueue.take();
						task.run();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
		
			} 	// end method run()
		}; 		// end new Thread()
		
		t.start();
		
	}			// end method createThread()

}
